/* An edge is defined as 2 nodes */



public class Edge
{
  public Edge(Node inx, Node iny)
  {
    x = inx;
    y = iny;
  }

  public String toString()
  {
     return x + "-->" + y;
  }

  public Node GetFirstNode()
  {
    return x;
  }

  public Node GetSecondNode()
  {
    return y;
  }

  public boolean isParallel(Edge a)
  {
    Node diff1 = x.subtractNode(y);
    Node m = a.GetFirstNode();
    Node n = a.GetSecondNode();
    Node diff2 = m.subtractNode(n);

    Node cp = diff1.crossProduct(diff2);
    if (cp.isOrigin())
      return true;

    return false;
  }

  public boolean isCoPlanar(Edge a)
  {
    Node m = a.GetFirstNode();
    Node n = a.GetSecondNode();

    Node d1 = x.subtractNode(y);
    Node d2 = m.subtractNode(x);
    Node d3 = n.subtractNode(x);

    Node cp1 = d1.crossProduct(d2);
    Node cp2 = d1.crossProduct(d3);

    if (cp1.isOrigin())
      return true; // case where parallal or colinear

    if (cp2.isOrigin())
      return true; // case where parallal or colinear

    Node ncp1 = cp1.normalise();
    Node ncp2 = cp2.normalise();

    if (ncp1.equals(ncp2))
      return true;

    return false;
  }


  public Node unitNormal(Edge a)
  {
    Node m = a.GetFirstNode();
    Node n = a.GetSecondNode();

    Node d1 = x.subtractNode(y);
    Node d2 = m.subtractNode(x);

    Node cp = d1.crossProduct(d2);

    if (cp.isOrigin())
      return null;

    Node ncp = cp.normalise();
    return ncp;
  }


  public boolean equals(Edge a)
  {
    Node one = a.GetFirstNode();
    Node two = a.GetSecondNode();
    
    if (x.equals(one) && y.equals(two))
      return true;

    return false;
  }

  private Node x;
  private Node y;
}










